# autogenerated file, do not modify

from os import PathLike, curdir
from typing import Union

from flopy.mf6.data.mfdatautil import ArrayTemplateGenerator, ListTemplateGenerator
from flopy.mf6.mfpackage import MFChildPackages, MFPackage


class ModflowGweic(MFPackage):
    """
    ModflowGweic defines a IC package.

    Parameters
    ----------
    export_array_ascii : keyword
        keyword that specifies input griddata arrays should be written to layered ascii
        output files.
    export_array_netcdf : keyword
        keyword that specifies input griddata arrays should be written to the model
        output netcdf file.
    strt : [double precision]
        is the initial (starting) temperature---that is, the temperature at the
        beginning of the gwe model simulation.  strt must be specified for all gwe
        model simulations. one value is read for every model cell.

    """

    strt = ArrayTemplateGenerator(("gwe6", "ic", "griddata", "strt"))
    package_abbr = "gweic"
    _package_type = "ic"
    dfn_file_name = "gwe-ic.dfn"
    dfn = [
        ["header"],
        [
            "block options",
            "name export_array_ascii",
            "type keyword",
            "reader urword",
            "optional true",
            "mf6internal export_ascii",
        ],
        [
            "block options",
            "name export_array_netcdf",
            "type keyword",
            "reader urword",
            "optional true",
            "mf6internal export_nc",
            "extended true",
        ],
        [
            "block griddata",
            "name strt",
            "type double precision",
            "shape (nodes)",
            "reader readarray",
            "layered true",
            "netcdf true",
            "default 0.0",
        ],
    ]

    def __init__(
        self,
        model,
        loading_package=False,
        export_array_ascii=None,
        export_array_netcdf=None,
        strt=0.0,
        filename=None,
        pname=None,
        **kwargs,
    ):
        """
        ModflowGweic defines a IC package.

        Parameters
        ----------
        model
            Model that this package is a part of. Package is automatically
            added to model when it is initialized.
        loading_package : bool
            Do not set this parameter. It is intended for debugging and internal
            processing purposes only.
        export_array_ascii : keyword
            keyword that specifies input griddata arrays should be written to layered ascii
            output files.
        export_array_netcdf : keyword
            keyword that specifies input griddata arrays should be written to the model
            output netcdf file.
        strt : [double precision]
            is the initial (starting) temperature---that is, the temperature at the
            beginning of the gwe model simulation.  strt must be specified for all gwe
            model simulations. one value is read for every model cell.

        filename : str
            File name for this package.
        pname : str
            Package name for this package.
        parent_file : MFPackage
            Parent package file that references this package. Only needed for
            utility packages (mfutl*). For example, mfutllaktab package must have
            a mfgwflak package parent_file.
        """

        super().__init__(model, "ic", filename, pname, loading_package, **kwargs)

        self.export_array_ascii = self.build_mfdata(
            "export_array_ascii", export_array_ascii
        )
        self.export_array_netcdf = self.build_mfdata(
            "export_array_netcdf", export_array_netcdf
        )
        self.strt = self.build_mfdata("strt", strt)

        self._init_complete = True
