# autogenerated file, do not modify


from os import PathLike, curdir
from typing import Union

from flopy.mf6.data.mfdatautil import ArrayTemplateGenerator, ListTemplateGenerator
from flopy.mf6.mfpackage import MFPackage


class ModflowGwfprt(MFPackage):
    """
    ModflowGwfprt defines a GWFPRT package.

    Parameters
    ----------

    """

    package_abbr = "gwfprt"
    _package_type = "gwfprt"
    dfn_file_name = "exg-gwfprt.dfn"
    dfn = [["header"]]

    def __init__(
        self,
        simulation,
        loading_package=False,
        exgtype="GWF6-PRT6",
        exgmnamea=None,
        exgmnameb=None,
        filename=None,
        pname=None,
        **kwargs,
    ):
        """
        ModflowGwfprt defines a GWFPRT package.

        simulation : MFSimulation
            Simulation that this package is a part of. Package is automatically
            added to simulation when it is initialized.
        loading_package : bool
            Do not set this parameter. It is intended for debugging and internal
            processing purposes only.
        exgtype : str
            The exchange type (GWF-GWF or GWF-GWT).
        exgmnamea : str
            The name of the first model that is part of this exchange.
        exgmnameb : str
            The name of the second model that is part of this exchange.
        gwfmodelname1 : str
            Name of first GWF Model. In the simulation name file, the GWE6-GWE6
            entry contains names for GWE Models (exgmnamea and exgmnameb). The
            GWE Model with the name exgmnamea must correspond to the GWF Model
            with the name gwfmodelname1.
        gwfmodelname2 : str
            Name of second GWF Model. In the simulation name file, the GWE6-GWE6
            entry contains names for GWE Models (exgmnamea and exgmnameb). The
            GWE Model with the name exgmnameb must correspond to the GWF Model
            with the name gwfmodelname2.

        """

        super().__init__(
            simulation, "gwfprt", filename, pname, loading_package, **kwargs
        )

        self.exgtype = exgtype
        self.exgmnamea = exgmnamea
        self.exgmnameb = exgmnameb
        simulation.register_exchange_file(self)

        self._init_complete = True
